(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common/http'), require('rxjs/operators'), require('@yukawa/chain-base-angular-client'), require('lodash'), require('@angular/common'), require('@ngx-translate/core')) :
    typeof define === 'function' && define.amd ? define('@yukawa/chain-crm-angular-core', ['exports', '@angular/core', '@angular/common/http', 'rxjs/operators', '@yukawa/chain-base-angular-client', 'lodash', '@angular/common', '@ngx-translate/core'], factory) :
    (global = global || self, factory((global.yukawa = global.yukawa || {}, global.yukawa['chain-crm-angular-core'] = {}), global.ng.core, global.ng.common.http, global.rxjs.operators, global.chainBaseAngularClient, global._, global.ng.common, global.core$1));
}(this, (function (exports, core, http, operators, chainBaseAngularClient, _, common, core$1) { 'use strict';

    _ = _ && _.hasOwnProperty('default') ? _['default'] : _;

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __createBinding(o, m, k, k2) {
        if (k2 === undefined) k2 = k;
        o[k2] = m[k];
    }

    function __exportStar(m, exports) {
        for (var p in m) if (p !== "default" && !exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m) return m.call(o);
        if (o && typeof o.length === "number") return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }

    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var AccountService = /** @class */ (function (_super) {
        __extends(AccountService, _super);
        function AccountService(http, configService) {
            return _super.call(this, http, configService) || this;
        }
        // searchAccount(filter: any): Observable<SearchResult<Partner>> {
        //     return this.search<Partner>(this.formatServiceUrl('/search'), filter);
        // }
        // searchAccount(filter: any): Observable<SearchResult<Partner>> {
        //     return this.search<Partner>(this.formatServiceUrl('/search'), filter);
        // }
        /**
         * @param {?} filter
         * @return {?}
         */
        AccountService.prototype.queryAccount = 
        // searchAccount(filter: any): Observable<SearchResult<Partner>> {
        //     return this.search<Partner>(this.formatServiceUrl('/search'), filter);
        // }
        /**
         * @param {?} filter
         * @return {?}
         */
        function (filter) {
            return this.query(this.formatServiceUrl('/query'), filter);
        };
        /**
         * @param {?=} partnerType
         * @param {?=} keyword
         * @return {?}
         */
        AccountService.prototype.queryAccountsAsList = /**
         * @param {?=} partnerType
         * @param {?=} keyword
         * @return {?}
         */
        function (partnerType, keyword) {
            return this.queryAccount({
                pager: { pageSize: 100, firstResult: 0 },
                keyword: keyword,
                partnerType: partnerType
            }).pipe(operators.map((/**
             * @param {?} value
             * @return {?}
             */
            function (value) { return value.items; })));
        };
        // queryAccountsAsListWithEmptyOption(): Observable<Partner []> {
        //     console.log()
        //     return this.queryAccount({pageSize: 1000000}).pipe(map(value => {
        //         value.items.push(<Partner>{});
        //         return value.items;
        //     }));
        // }
        // queryAccountsAsListWithEmptyOption(): Observable<Partner []> {
        //     console.log()
        //     return this.queryAccount({pageSize: 1000000}).pipe(map(value => {
        //         value.items.push(<Partner>{});
        //         return value.items;
        //     }));
        // }
        /**
         * @param {?} partner
         * @return {?}
         */
        AccountService.prototype.mergeAccount = 
        // queryAccountsAsListWithEmptyOption(): Observable<Partner []> {
        //     console.log()
        //     return this.queryAccount({pageSize: 1000000}).pipe(map(value => {
        //         value.items.push(<Partner>{});
        //         return value.items;
        //     }));
        // }
        /**
         * @param {?} partner
         * @return {?}
         */
        function (partner) {
            return this.edit(this.formatServiceUrl("/merge"), partner, { method: 'post' });
        };
        /**
         * @param {?} id
         * @return {?}
         */
        AccountService.prototype.loadAccount = /**
         * @param {?} id
         * @return {?}
         */
        function (id) {
            var _this = this;
            return this.load(this.formatServiceUrl('') + "/?key=" + id)
                .pipe(operators.map((/**
             * @param {?} value
             * @return {?}
             */
            function (value) { return _this.checkNotNull(value); })));
        };
        /**
         * @param {?} account
         * @param {?=} type
         * @return {?}
         */
        AccountService.prototype.saveAccount = /**
         * @param {?} account
         * @param {?=} type
         * @return {?}
         */
        function (account, type) {
            if (type === void 0) { type = "create"; }
            return this.edit(this.formatServiceUrl("/" + type), account, { method: 'post' });
        };
        /**
         * @param {?} id
         * @return {?}
         */
        AccountService.prototype.deleteAccount = /**
         * @param {?} id
         * @return {?}
         */
        function (id) {
            return this.http.delete(this.formatServiceUrl('') + "/?key=" + id);
        };
        /**
         * @return {?}
         */
        AccountService.prototype.newAccount = /**
         * @return {?}
         */
        function () {
            var _this = this;
            return this.http.post("" + this.formatServiceUrl('/new'), {})
                .pipe(operators.map((/**
             * @param {?} value
             * @return {?}
             */
            function (value) { return _this.checkNotNull(value); })));
        };
        /**
         * @param {?} filter
         * @return {?}
         */
        AccountService.prototype.export = /**
         * @param {?} filter
         * @return {?}
         */
        function (filter) {
            /** @type {?} */
            var opts = {
                headers: new http.HttpHeaders({
                    'Content-Type': 'application/json'
                    //'Accept': 'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet'
                })
            };
            return this.download("" + this.formatServiceUrl('/export'), filter, opts);
        };
        /**
         * @protected
         * @param {?=} path
         * @return {?}
         */
        AccountService.prototype.formatServiceUrl = /**
         * @protected
         * @param {?=} path
         * @return {?}
         */
        function (path) {
            if (path === void 0) { path = ''; }
            return this.configService.formatUrl("partnerUrl") + path;
        };
        AccountService.decorators = [
            { type: core.Injectable, args: [{
                        providedIn: 'root'
                    },] }
        ];
        /** @nocollapse */
        AccountService.ctorParameters = function () { return [
            { type: http.HttpClient, decorators: [{ type: core.Inject, args: [core.forwardRef((/**
                             * @return {?}
                             */
                            function () { return http.HttpClient; })),] }] },
            { type: chainBaseAngularClient.ConfigService, decorators: [{ type: core.Inject, args: [core.forwardRef((/**
                             * @return {?}
                             */
                            function () { return chainBaseAngularClient.ConfigService; })),] }] }
        ]; };
        /** @nocollapse */ AccountService.ngInjectableDef = core.ɵɵdefineInjectable({ factory: function AccountService_Factory() { return new AccountService(core.ɵɵinject(http.HttpClient), core.ɵɵinject(chainBaseAngularClient.ConfigService)); }, token: AccountService, providedIn: "root" });
        return AccountService;
    }(chainBaseAngularClient.RestAspect));
    if (false) {
        /** @type {?} */
        AccountService.prototype.Accounts;
    }
    var RelationService = /** @class */ (function (_super) {
        __extends(RelationService, _super);
        function RelationService(http, configService) {
            return _super.call(this, http, configService) || this;
        }
        /**
         * @param {?} filter
         * @return {?}
         */
        RelationService.prototype.searchRelation = /**
         * @param {?} filter
         * @return {?}
         */
        function (filter) {
            return this.search(this.formatServiceUrl('/search'), filter);
        };
        /**
         * @param {?} filter
         * @return {?}
         */
        RelationService.prototype.queryRelation = /**
         * @param {?} filter
         * @return {?}
         */
        function (filter) {
            return this.query(this.formatServiceUrl('/query'), filter);
        };
        /**
         * @param {?} id
         * @return {?}
         */
        RelationService.prototype.loadRelation = /**
         * @param {?} id
         * @return {?}
         */
        function (id) {
            var _this = this;
            return this.load(this.formatServiceUrl('') + "/?key=" + id)
                .pipe(operators.map((/**
             * @param {?} value
             * @return {?}
             */
            function (value) { return _this.checkNotNull(value); })));
        };
        /**
         * @param {?} relation
         * @param {?=} type
         * @return {?}
         */
        RelationService.prototype.saveRelation = /**
         * @param {?} relation
         * @param {?=} type
         * @return {?}
         */
        function (relation, type) {
            if (type === void 0) { type = "create"; }
            return this.edit(this.formatServiceUrl("/" + type), relation, { method: 'post' });
        };
        /**
         * @param {?} id
         * @return {?}
         */
        RelationService.prototype.deleteRelation = /**
         * @param {?} id
         * @return {?}
         */
        function (id) {
            return this.http.delete(this.formatServiceUrl('') + "/?key=" + id);
        };
        /**
         * @param {?} partnerId
         * @param {?} role
         * @param {?} traversalDir
         * @return {?}
         */
        RelationService.prototype.traverseRelations = /**
         * @param {?} partnerId
         * @param {?} role
         * @param {?} traversalDir
         * @return {?}
         */
        function (partnerId, role, traversalDir) {
            return this.http.get(this.formatServiceUrl('/traverse') + "?partnerId=" + partnerId + "&role=" + role + "&traversalDir=" + traversalDir);
        };
        /**
         * @protected
         * @param {?=} path
         * @return {?}
         */
        RelationService.prototype.formatServiceUrl = /**
         * @protected
         * @param {?=} path
         * @return {?}
         */
        function (path) {
            if (path === void 0) { path = ''; }
            return this.configService.formatUrl("relationUrl") + path;
        };
        RelationService.decorators = [
            { type: core.Injectable, args: [{
                        providedIn: 'root'
                    },] }
        ];
        /** @nocollapse */
        RelationService.ctorParameters = function () { return [
            { type: http.HttpClient, decorators: [{ type: core.Inject, args: [core.forwardRef((/**
                             * @return {?}
                             */
                            function () { return http.HttpClient; })),] }] },
            { type: chainBaseAngularClient.ConfigService, decorators: [{ type: core.Inject, args: [core.forwardRef((/**
                             * @return {?}
                             */
                            function () { return chainBaseAngularClient.ConfigService; })),] }] }
        ]; };
        /** @nocollapse */ RelationService.ngInjectableDef = core.ɵɵdefineInjectable({ factory: function RelationService_Factory() { return new RelationService(core.ɵɵinject(http.HttpClient), core.ɵɵinject(chainBaseAngularClient.ConfigService)); }, token: RelationService, providedIn: "root" });
        return RelationService;
    }(chainBaseAngularClient.RestAspect));
    if (false) {
        /** @type {?} */
        RelationService.prototype.Relations;
    }
    var ContactLogService = /** @class */ (function (_super) {
        __extends(ContactLogService, _super);
        function ContactLogService(http, configService) {
            return _super.call(this, http, configService, configService.formatUrl("contactLogUrl")) || this;
        }
        /**
         * @param {?} filter
         * @return {?}
         */
        ContactLogService.prototype.searchContactLog = /**
         * @param {?} filter
         * @return {?}
         */
        function (filter) {
            return this.search(this.formatServiceUrl('/search'), filter);
        };
        /**
         * @param {?} filter
         * @return {?}
         */
        ContactLogService.prototype.queryContactLog = /**
         * @param {?} filter
         * @return {?}
         */
        function (filter) {
            return this.query(this.formatServiceUrl('/query'), filter);
        };
        /**
         * @param {?} id
         * @return {?}
         */
        ContactLogService.prototype.loadContactLog = /**
         * @param {?} id
         * @return {?}
         */
        function (id) {
            var _this = this;
            return this.load(this.formatServiceUrl('') + "/?key=" + id)
                .pipe(operators.map((/**
             * @param {?} value
             * @return {?}
             */
            function (value) { return _this.checkNotNull(value); })));
        };
        /**
         * @param {?} contactLog
         * @param {?=} type
         * @return {?}
         */
        ContactLogService.prototype.saveContactLog = /**
         * @param {?} contactLog
         * @param {?=} type
         * @return {?}
         */
        function (contactLog, type) {
            if (type === void 0) { type = "create"; }
            return this.edit(this.formatServiceUrl("/" + type), contactLog, { method: 'post' });
        };
        /**
         * @param {?} id
         * @return {?}
         */
        ContactLogService.prototype.deleteContactLog = /**
         * @param {?} id
         * @return {?}
         */
        function (id) {
            return this.http.delete(this.formatServiceUrl('') + "/?key=" + id);
        };
        ContactLogService.decorators = [
            { type: core.Injectable, args: [{
                        providedIn: 'root'
                    },] }
        ];
        /** @nocollapse */
        ContactLogService.ctorParameters = function () { return [
            { type: http.HttpClient, decorators: [{ type: core.Inject, args: [core.forwardRef((/**
                             * @return {?}
                             */
                            function () { return http.HttpClient; })),] }] },
            { type: chainBaseAngularClient.ConfigService, decorators: [{ type: core.Inject, args: [core.forwardRef((/**
                             * @return {?}
                             */
                            function () { return chainBaseAngularClient.ConfigService; })),] }] }
        ]; };
        /** @nocollapse */ ContactLogService.ngInjectableDef = core.ɵɵdefineInjectable({ factory: function ContactLogService_Factory() { return new ContactLogService(core.ɵɵinject(http.HttpClient), core.ɵɵinject(chainBaseAngularClient.ConfigService)); }, token: ContactLogService, providedIn: "root" });
        return ContactLogService;
    }(chainBaseAngularClient.RestAspect));
    if (false) {
        /** @type {?} */
        ContactLogService.prototype.Contacts;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @enum {string} */
    var PartnerType = {
        COMPANY: "company",
        PERSON: "person",
    };
    /** @type {?} */
    var partnerTypes = [];
    for (var n in PartnerType) {
        partnerTypes.push(PartnerType[n]);
    }
    /**
     * @record
     */
    function RelationConfig() { }
    if (false) {
        /** @type {?} */
        RelationConfig.prototype.source;
        /** @type {?} */
        RelationConfig.prototype.target;
        /** @type {?} */
        RelationConfig.prototype.role;
        /** @type {?} */
        RelationConfig.prototype.relation;
        /** @type {?} */
        RelationConfig.prototype.inverseRelation;
        /** @type {?|undefined} */
        RelationConfig.prototype.perspective;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @record
     */
    function AccountFilter() { }
    if (false) {
        /** @type {?|undefined} */
        AccountFilter.prototype.keyword;
        /** @type {?} */
        AccountFilter.prototype.partnerType;
    }
    /**
     * @record
     */
    function RelationFilter() { }
    if (false) {
        /** @type {?|undefined} */
        RelationFilter.prototype.keyword;
        /** @type {?|undefined} */
        RelationFilter.prototype.partnerId;
        /** @type {?|undefined} */
        RelationFilter.prototype.partnerTargetId;
        /** @type {?|undefined} */
        RelationFilter.prototype.partnerSourceId;
        /** @type {?|undefined} */
        RelationFilter.prototype.targetOrSourceIds;
        /** @type {?|undefined} */
        RelationFilter.prototype.role;
    }
    /**
     * @record
     */
    function ContactLogFilter() { }
    if (false) {
        /** @type {?|undefined} */
        ContactLogFilter.prototype.keyword;
        /** @type {?|undefined} */
        ContactLogFilter.prototype.partnerId;
        /** @type {?|undefined} */
        ContactLogFilter.prototype.communicationChannel;
        /** @type {?|undefined} */
        ContactLogFilter.prototype.participantId;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @record
     */
    function AccountAspect() { }
    if (false) {
        /** @type {?} */
        AccountAspect.prototype.Accounts;
        /**
         * @param {?} filter
         * @return {?}
         */
        AccountAspect.prototype.queryAccount = function (filter) { };
        /**
         * @param {?} id
         * @param {?} shortName
         * @return {?}
         */
        AccountAspect.prototype.loadAccount = function (id, shortName) { };
        /**
         * @param {?} partner
         * @return {?}
         */
        AccountAspect.prototype.saveAccount = function (partner) { };
        /**
         * @param {?} id
         * @return {?}
         */
        AccountAspect.prototype.deleteAccount = function (id) { };
        /**
         * @param {?} id
         * @param {?} shortName
         * @return {?}
         */
        AccountAspect.prototype.newAccount = function (id, shortName) { };
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var withType = (/**
     * @param {?} partner
     * @param {?} type
     * @return {?}
     */
    function (partner, type) { return partner.partnerType === type; });
    /** @type {?} */
    var withId = (/**
     * @param {?} partner
     * @param {?} id
     * @return {?}
     */
    function (partner, id) { return partner.partnerId === id; });
    /** @type {?} */
    var sortByCompanyName = (/**
     * @param {?} p1
     * @param {?} p2
     * @return {?}
     */
    function (p1, p2) {
        if (p1.companyName && p2.companyName) {
            return p1.companyName.localeCompare(p2.companyName);
        }
        return 0;
    });
    /** @type {?} */
    var sortByLastName = (/**
     * @param {?} p1
     * @param {?} p2
     * @return {?}
     */
    function (p1, p2) {
        if (p1.lastName && p2.lastName) {
            return p1.lastName.localeCompare(p2.lastName);
        }
        return 0;
    });
    var AccountUtilities = /** @class */ (function () {
        function AccountUtilities() {
        }
        /**
         * @param {?} partners
         * @param {?} partnerId
         * @return {?}
         */
        AccountUtilities.getPartnerById = /**
         * @param {?} partners
         * @param {?} partnerId
         * @return {?}
         */
        function (partners, partnerId) {
            /** @type {?} */
            var ifExist = partners.find((/**
             * @param {?} val
             * @return {?}
             */
            function (val) { return val.partnerId === partnerId; }));
            return ifExist;
        };
        /**
         * @param {?} partner
         * @param {?=} partnerType
         * @return {?}
         */
        AccountUtilities.getDisplayName = /**
         * @param {?} partner
         * @param {?=} partnerType
         * @return {?}
         */
        function (partner, partnerType) {
            if (partner && partner.partnerType) {
                return partner.partnerType === PartnerType.COMPANY ? partner.companyName : partner.firstName + ' ' + partner.lastName;
            }
            if (partnerType) {
                return partnerType === PartnerType.COMPANY.toString() ? partner.companyName : partner.firstName + ' ' + partner.lastName;
            }
            return "";
        };
        /**
         * @param {?} partner1
         * @param {?} partner2
         * @return {?}
         */
        AccountUtilities.compareWith = /**
         * @param {?} partner1
         * @param {?} partner2
         * @return {?}
         */
        function (partner1, partner2) {
            return partner1 && partner2 ? partner1.partnerId === partner2.partnerId : -1;
        };
        /**
         * @param {?} partner
         * @return {?}
         */
        AccountUtilities.buildPartnerInfo = /**
         * @param {?} partner
         * @return {?}
         */
        function (partner) {
            /** @type {?} */
            var subset = ((/**
             * @param {?} __0
             * @return {?}
             */
            function (_a) {
                var companyName = _a.companyName, email = _a.email, firstName = _a.firstName, lastName = _a.lastName, partnerId = _a.partnerId, shortName = _a.shortName;
                return ({
                    companyName: companyName,
                    email: email,
                    firstName: firstName,
                    lastName: lastName,
                    partnerId: partnerId,
                    shortName: shortName
                });
            }));
            return subset(partner);
        };
        /**
         * @param {?} accounts
         * @param {?} subject
         * @param {?} filterCtrl
         * @return {?}
         */
        AccountUtilities.filterAccounts = /**
         * @param {?} accounts
         * @param {?} subject
         * @param {?} filterCtrl
         * @return {?}
         */
        function (accounts, subject, filterCtrl) {
            if (!accounts) {
                return;
            }
            // get the search keyword
            /** @type {?} */
            var search = filterCtrl.value;
            if (!search) {
                subject.next(accounts.slice());
                return;
            }
            else {
                search = search.toLowerCase();
            }
            // filter the accounts
            subject.next(accounts.filter((/**
             * @param {?} account
             * @return {?}
             */
            function (account) {
                if (account.companyName) {
                    return account.companyName.toLowerCase().indexOf(search) > -1;
                }
                if (account.firstName && account.lastName) {
                    return account.firstName.toLowerCase().indexOf(search) > -1 || account.lastName.toLowerCase().indexOf(search) > -1;
                }
            })));
        };
        return AccountUtilities;
    }());
    if (false) {
        /** @type {?} */
        AccountUtilities.prototype.partner;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var AddressUtils = /** @class */ (function () {
        function AddressUtils() {
        }
        /**
         * @param {?} address
         * @param {?} type
         * @return {?}
         */
        AddressUtils.findAddressByType = /**
         * @param {?} address
         * @param {?} type
         * @return {?}
         */
        function (address, type) {
            var _this = this;
            /** @type {?} */
            var _address = address.filter((/**
             * @param {?} val
             * @return {?}
             */
            function (val) { return val.type != null; })).find((/**
             * @param {?} val
             * @return {?}
             */
            function (val) { return val.type === _this.TYPE_INVOICE; }));
            return _address;
        };
        /**
         * @param {?} fb
         * @param {?=} initial
         * @param {?=} validators
         * @return {?}
         */
        AddressUtils.getFormGroup = /**
         * @param {?} fb
         * @param {?=} initial
         * @param {?=} validators
         * @return {?}
         */
        function (fb, initial, validators) {
            /** @type {?} */
            var group = fb.group({
                type: [null, null],
                street: [null, null],
                houseNumber: [null, null],
                countryCode: [null, null],
                city: [null, null],
                zipCode: [null, null],
                desc: [null, null]
            });
            if (initial) {
                group.patchValue(initial);
            }
            return group;
        };
        /**
         * @param {?} fa
         * @param {?} fb
         * @param {?=} initial
         * @return {?}
         */
        AddressUtils.addAddressToFormArray = /**
         * @param {?} fa
         * @param {?} fb
         * @param {?=} initial
         * @return {?}
         */
        function (fa, fb, initial) {
            /** @type {?} */
            var formArray = (/** @type {?} */ (fa));
            formArray.push(this.getFormGroup(fb, initial));
        };
        /**
         * @param {?} fa
         * @param {?} fb
         * @param {?=} initial
         * @return {?}
         */
        AddressUtils.addAndGetAddress = /**
         * @param {?} fa
         * @param {?} fb
         * @param {?=} initial
         * @return {?}
         */
        function (fa, fb, initial) {
            /** @type {?} */
            var formArray = (/** @type {?} */ (fa));
            /** @type {?} */
            var group = this.getFormGroup(fb, initial);
            formArray.push(group);
            return group;
        };
        AddressUtils.TYPE_INVOICE = "INVOICE";
        return AddressUtils;
    }());
    if (false) {
        /** @type {?} */
        AddressUtils.TYPE_INVOICE;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @enum {string} */
    var PartnerType$1 = {
        COMPANY: "company",
        PERSON: "person",
    };
    /** @type {?} */
    var partnerTypes$1 = [];
    for (var n$1 in PartnerType$1) {
        partnerTypes$1.push(PartnerType$1[n$1]);
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    // configuration of possible roles in a relation
    // the convention is that the relation represents the natural understanding of: source - role - target
    /** @type {?} */
    var relationsConfig = [
        {
            source: PartnerType$1.COMPANY,
            target: PartnerType$1.COMPANY,
            role: "isHoldingOf",
            relation: "Is holding of",
            inverseRelation: "Is subsidiary of"
        },
        {
            source: PartnerType$1.PERSON,
            target: PartnerType$1.COMPANY,
            relation: "is employee of",
            inverseRelation: "employs",
            role: "isEmployeeOf"
        },
        {
            source: PartnerType$1.COMPANY,
            target: PartnerType$1.COMPANY,
            relation: "is supplier of",
            inverseRelation: "has supplier",
            role: "isSupplierOf",
        },
    ];
    /** @enum {string} */
    var RelationRole = {
        HOLDING_OF: "isHoldingOf",
        EMPLOYEE_OF: "isEmployeeOf",
        SUPPLIER_OF: "isSupplierOf",
    };
    /** @type {?} */
    var relationRoles = [];
    for (var n$2 in RelationRole) {
        relationRoles.push(PartnerType$1[n$2]);
    }
    var RelationConfigService = /** @class */ (function () {
        function RelationConfigService() {
        }
        // -----------------------------------------------------------------------------------------------------
        // @ Utility Methods
        // -----------------------------------------------------------------------------------------------------
        /**
         *
         * @param type1
         * @param type2
         * @returns all relation configs where type1 -> type2 or type2 -> type1
         */
        // -----------------------------------------------------------------------------------------------------
        // @ Utility Methods
        // -----------------------------------------------------------------------------------------------------
        /**
         *
         * @param {?} type1
         * @param {?} type2
         * @return {?} all relation configs where type1 -> type2 or type2 -> type1
         */
        RelationConfigService.getRelationConfigsUndirected = 
        // -----------------------------------------------------------------------------------------------------
        // @ Utility Methods
        // -----------------------------------------------------------------------------------------------------
        /**
         *
         * @param {?} type1
         * @param {?} type2
         * @return {?} all relation configs where type1 -> type2 or type2 -> type1
         */
        function (type1, type2) {
            /** @type {?} */
            var _config = relationsConfig.filter(((/**
             * @param {?} value
             * @return {?}
             */
            function (value) {
                return (value.source === type1 && value.target === type2) ||
                    (value.source === type2 && value.target === type1);
            })));
            return _config;
        };
        /**
         *
         * @param source
         * @param target
         * @returns all relation configs that exist from source type to target type
         */
        /**
         *
         * @param {?} source
         * @param {?} target
         * @return {?} all relation configs that exist from source type to target type
         */
        RelationConfigService.getRelationConfigsDirected = /**
         *
         * @param {?} source
         * @param {?} target
         * @return {?} all relation configs that exist from source type to target type
         */
        function (source, target) {
            /** @type {?} */
            var _relationConfig = relationsConfig.filter(((/**
             * @param {?} value
             * @return {?}
             */
            function (value) {
                return (value.source === source && value.target === target);
            })));
            return _relationConfig;
        };
        /**
         *
         * @param role
         * @returns the unique RelationConfig for a role
         */
        /**
         *
         * @param {?} role
         * @return {?} the unique RelationConfig for a role
         */
        RelationConfigService.getRelationConfigForRole = /**
         *
         * @param {?} role
         * @return {?} the unique RelationConfig for a role
         */
        function (role) {
            /** @type {?} */
            var _relationConfig = relationsConfig.filter((/**
             * @param {?} value
             * @return {?}
             */
            function (value) { return value.role === role; })).find((/**
             * @param {?} x
             * @return {?}
             */
            function (x) { return x !== undefined; }));
            return _relationConfig;
        };
        /**
         *
         * @param rel relation
         * @param partnerId the partner that appears either as source or as target in rel
         * @returns returns the relation designation
         */
        /**
         *
         * @param {?} rel relation
         * @param {?} partnerId the partner that appears either as source or as target in rel
         * @return {?} returns the relation designation
         */
        RelationConfigService.getDisplayedRelation = /**
         *
         * @param {?} rel relation
         * @param {?} partnerId the partner that appears either as source or as target in rel
         * @return {?} returns the relation designation
         */
        function (rel, partnerId) {
            /** @type {?} */
            var config = this.getRelationConfigForRole(rel.role);
            return rel.sourcePartner.partnerId === partnerId ? config.relation : config.inverseRelation;
        };
        /**
         *
         * @param type
         * @returns all configurations including type either as source or target
         */
        /**
         *
         * @param {?} type
         * @return {?} all configurations including type either as source or target
         */
        RelationConfigService.getRelationConfigsIncludingType = /**
         *
         * @param {?} type
         * @return {?} all configurations including type either as source or target
         */
        function (type) {
            var e_1, _a;
            /** @type {?} */
            var configs = relationsConfig.filter((/**
             * @param {?} value
             * @return {?}
             */
            function (value) { return value.source === type || value.target === type; }));
            try {
                for (var configs_1 = __values(configs), configs_1_1 = configs_1.next(); !configs_1_1.done; configs_1_1 = configs_1.next()) {
                    var config = configs_1_1.value;
                    if (config.target === type) {
                        config.perspective = 'target';
                    }
                    else {
                        config.perspective = 'source';
                    }
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (configs_1_1 && !configs_1_1.done && (_a = configs_1.return)) _a.call(configs_1);
                }
                finally { if (e_1) throw e_1.error; }
            }
            return configs;
        };
        /**
         *
         * @param type
         * @returns all configurations including type either source
         */
        /**
         *
         * @param {?} type
         * @return {?} all configurations including type either source
         */
        RelationConfigService.getRelationConfigsIncludingTypeAsSource = /**
         *
         * @param {?} type
         * @return {?} all configurations including type either source
         */
        function (type) {
            var e_2, _a;
            /** @type {?} */
            var res = _.cloneDeep((relationsConfig.filter((/**
             * @param {?} value
             * @return {?}
             */
            function (value) { return value.source === type; }))));
            try {
                for (var res_1 = __values(res), res_1_1 = res_1.next(); !res_1_1.done; res_1_1 = res_1.next()) {
                    var val = res_1_1.value;
                    val.perspective = 'source';
                }
            }
            catch (e_2_1) { e_2 = { error: e_2_1 }; }
            finally {
                try {
                    if (res_1_1 && !res_1_1.done && (_a = res_1.return)) _a.call(res_1);
                }
                finally { if (e_2) throw e_2.error; }
            }
            return res;
        };
        /**
         *
         * @param type
         * @returns all configurations including type either source
         */
        /**
         *
         * @param {?} type
         * @return {?} all configurations including type either source
         */
        RelationConfigService.getRelationConfigsIncludingTypeAsTarget = /**
         *
         * @param {?} type
         * @return {?} all configurations including type either source
         */
        function (type) {
            var e_3, _a;
            /** @type {?} */
            var res = _.cloneDeep(relationsConfig.filter((/**
             * @param {?} value
             * @return {?}
             */
            function (value) { return value.target === type; })));
            try {
                for (var res_2 = __values(res), res_2_1 = res_2.next(); !res_2_1.done; res_2_1 = res_2.next()) {
                    var val = res_2_1.value;
                    val.perspective = 'target';
                }
            }
            catch (e_3_1) { e_3 = { error: e_3_1 }; }
            finally {
                try {
                    if (res_2_1 && !res_2_1.done && (_a = res_2.return)) _a.call(res_2);
                }
                finally { if (e_3) throw e_3.error; }
            }
            return res;
        };
        return RelationConfigService;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * \@generator rest2ts
     * 	javaType: inc.yukawa.chain.crm.base.core.domain.Billing <br/>
     * @record
     */
    function Billing() { }
    if (false) {
        /** @type {?|undefined} */
        Billing.prototype.bankAccount;
        /** @type {?|undefined} */
        Billing.prototype.invoiceText;
        /** @type {?|undefined} */
        Billing.prototype.notes;
        /** @type {?|undefined} */
        Billing.prototype.paymentConditions;
    }
    /**
     * \@generator rest2ts
     * 	javaType: inc.yukawa.chain.crm.base.core.domain.ContactLog <br/>
     * @record
     */
    function ContactLog() { }
    if (false) {
        /** @type {?|undefined} */
        ContactLog.prototype.change;
        /**
         * 	values: email, phone<br/>
         * \@example email
         * @type {?|undefined}
         */
        ContactLog.prototype.communicationChannel;
        /** @type {?|undefined} */
        ContactLog.prototype.contactLogId;
        /** @type {?|undefined} */
        ContactLog.prototype.created;
        /**
         * @deprecated
         * @type {?|undefined}
         */
        ContactLog.prototype.dateRange;
        /** @type {?|undefined} */
        ContactLog.prototype.duration;
        /** @type {?|undefined} */
        ContactLog.prototype.info;
        /** @type {?|undefined} */
        ContactLog.prototype.location;
        /** @type {?|undefined} */
        ContactLog.prototype.notes;
        /** @type {?|undefined} */
        ContactLog.prototype.orgId;
        /** @type {?|undefined} */
        ContactLog.prototype.participants;
        /** @type {?|undefined} */
        ContactLog.prototype.projectId;
        /**
         * 	values: new, pending, done, archived<br/>
         * \@example new
         * @type {?|undefined}
         */
        ContactLog.prototype.status;
        /** @type {?|undefined} */
        ContactLog.prototype.taskId;
    }
    /**
     * \@generator rest2ts
     * 	javaType: inc.yukawa.chain.crm.base.core.domain.Participant <br/>
     * @record
     */
    function Participant() { }
    if (false) {
        /** @type {?|undefined} */
        Participant.prototype.participantId;
        /** @type {?|undefined} */
        Participant.prototype.role;
    }
    /**
     * \@generator rest2ts
     * 	javaType: inc.yukawa.chain.crm.base.core.domain.Partner <br/>
     * @record
     */
    function Partner() { }
    if (false) {
        /** @type {?|undefined} */
        Partner.prototype.billing;
        /** @type {?|undefined} */
        Partner.prototype.classification;
        /** @type {?|undefined} */
        Partner.prototype.displayName;
        /** @type {?|undefined} */
        Partner.prototype.jobDesc;
        /** @type {?|undefined} */
        Partner.prototype.masterContractAvailable;
        /** @type {?|undefined} */
        Partner.prototype.nda;
        /** @type {?|undefined} */
        Partner.prototype.orgId;
        /** @type {?|undefined} */
        Partner.prototype.partnerId;
        /**
         * 	values: person, company<br/>
         * \@example person
         * @type {?|undefined}
         */
        Partner.prototype.partnerType;
        /**
         * 	values: email, phone<br/>
         * \@example email
         * @type {?|undefined}
         */
        Partner.prototype.preferredCommunicationChannel;
        /**
         * 	values: active, inactive, blocked<br/>
         * @type {?|undefined}
         */
        Partner.prototype.status;
    }
    /**
     * \@generator rest2ts
     * 	javaType: inc.yukawa.chain.crm.base.core.domain.PartnerInfo <br/>
     * @record
     */
    function PartnerInfo() { }
    if (false) {
        /** @type {?|undefined} */
        PartnerInfo.prototype.classification;
        /** @type {?|undefined} */
        PartnerInfo.prototype.companyName;
        /** @type {?|undefined} */
        PartnerInfo.prototype.email;
        /** @type {?|undefined} */
        PartnerInfo.prototype.firstName;
        /** @type {?|undefined} */
        PartnerInfo.prototype.lastName;
        /** @type {?|undefined} */
        PartnerInfo.prototype.partnerId;
        /** @type {?|undefined} */
        PartnerInfo.prototype.partnerType;
        /** @type {?|undefined} */
        PartnerInfo.prototype.shortName;
    }
    /**
     * \@generator rest2ts
     * 	javaType: inc.yukawa.chain.crm.base.core.domain.Relation <br/>
     * @record
     */
    function Relation() { }
    if (false) {
        /** @type {?|undefined} */
        Relation.prototype.change;
        /**
         * \@example Lead, Engineer
         * @type {?|undefined}
         */
        Relation.prototype.classifier;
        /** @type {?|undefined} */
        Relation.prototype.created;
        /** @type {?|undefined} */
        Relation.prototype.orgId;
        /** @type {?|undefined} */
        Relation.prototype.relationId;
        /**
         * 	values: customer, employee, employer<br/>
         * \@example customer
         * @type {?|undefined}
         */
        Relation.prototype.role;
        /** @type {?|undefined} */
        Relation.prototype.sourcePartner;
        /** @type {?|undefined} */
        Relation.prototype.targetPartner;
    }
    /**
     * \@generator rest2ts
     * 	javaType: inc.yukawa.chain.crm.base.core.domain.Reminder <br/>
     * @record
     */
    function Reminder() { }
    if (false) {
        /** @type {?|undefined} */
        Reminder.prototype.change;
        /**
         * 	values: email, phone<br/>
         * \@example email
         * @type {?|undefined}
         */
        Reminder.prototype.communicationChannel;
        /** @type {?|undefined} */
        Reminder.prototype.created;
        /** @type {?|undefined} */
        Reminder.prototype.dueDate;
        /** @type {?|undefined} */
        Reminder.prototype.notes;
        /** @type {?|undefined} */
        Reminder.prototype.orgId;
        /** @type {?|undefined} */
        Reminder.prototype.reminderId;
        /** @type {?|undefined} */
        Reminder.prototype.reminderPartnerId;
        /**
         * 	values: new, pending, done, archived<br/>
         * \@example new
         * @type {?|undefined}
         */
        Reminder.prototype.status;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * \@generator rest2ts
     * 	javaType: inc.yukawa.chain.crm.base.core.filter.PartnerFilter <br/>
     * @record
     */
    function PartnerFilter() { }
    if (false) {
        /** @type {?|undefined} */
        PartnerFilter.prototype.classification;
        /** @type {?|undefined} */
        PartnerFilter.prototype.companyName;
        /** @type {?|undefined} */
        PartnerFilter.prototype.email;
        /** @type {?|undefined} */
        PartnerFilter.prototype.firstName;
        /** @type {?|undefined} */
        PartnerFilter.prototype.lastName;
        /** @type {?|undefined} */
        PartnerFilter.prototype.mobile;
        /** @type {?|undefined} */
        PartnerFilter.prototype.partnerId;
        /** @type {?|undefined} */
        PartnerFilter.prototype.partnerType;
        /** @type {?|undefined} */
        PartnerFilter.prototype.phoneNumber;
        /** @type {?|undefined} */
        PartnerFilter.prototype.preferredCommunicationChannel;
        /** @type {?|undefined} */
        PartnerFilter.prototype.role;
    }
    /**
     * \@generator rest2ts
     * 	javaType: inc.yukawa.chain.crm.base.core.filter.ReminderFilter <br/>
     * @record
     */
    function ReminderFilter() { }
    if (false) {
        /** @type {?|undefined} */
        ReminderFilter.prototype.communicationChannel;
        /** @type {?|undefined} */
        ReminderFilter.prototype.dueDateRange;
        /** @type {?|undefined} */
        ReminderFilter.prototype.notes;
        /** @type {?|undefined} */
        ReminderFilter.prototype.reminderId;
        /** @type {?|undefined} */
        ReminderFilter.prototype.reminderPartnerId;
        /** @type {?|undefined} */
        ReminderFilter.prototype.status;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * \@generator rest2ts
     * 	javaType: inc.yukawa.chain.crm.partner.service.rest.ContactLogRest <br/>
     */
    var ContactLogRest = /** @class */ (function () {
        function ContactLogRest(httpService) {
            this.httpService = httpService;
        }
        ContactLogRest.decorators = [
            { type: core.Injectable }
        ];
        /** @nocollapse */
        ContactLogRest.ctorParameters = function () { return [
            { type: http.HttpClient }
        ]; };
        return ContactLogRest;
    }());
    if (false) {
        /** @type {?} */
        ContactLogRest.prototype.httpService;
    }
    /**
     * \@generator rest2ts
     * 	javaType: inc.yukawa.chain.crm.partner.service.rest.PartnerRest <br/>
     */
    var PartnerRest = /** @class */ (function () {
        function PartnerRest(httpService) {
            this.httpService = httpService;
        }
        PartnerRest.decorators = [
            { type: core.Injectable }
        ];
        /** @nocollapse */
        PartnerRest.ctorParameters = function () { return [
            { type: http.HttpClient }
        ]; };
        return PartnerRest;
    }());
    if (false) {
        /** @type {?} */
        PartnerRest.prototype.httpService;
    }
    /**
     * \@generator rest2ts
     * 	javaType: inc.yukawa.chain.crm.partner.service.rest.RelationRest <br/>
     */
    var RelationRest = /** @class */ (function () {
        function RelationRest(httpService) {
            this.httpService = httpService;
        }
        /**
         * @param {?} partnerId
         * @param {?} role
         * @param {?} traversalDir
         * @return {?}
         */
        RelationRest.prototype.traverseRelations = /**
         * @param {?} partnerId
         * @param {?} role
         * @param {?} traversalDir
         * @return {?}
         */
        function (partnerId, role, traversalDir) {
            var e_1, _a;
            /** @type {?} */
            var queryParamsList = [];
            queryParamsList.push({ name: 'partnerId', value: partnerId });
            queryParamsList.push({ name: 'role', value: role });
            queryParamsList.push({ name: 'traversalDir', value: traversalDir });
            /** @type {?} */
            var params = new http.HttpParams();
            try {
                for (var queryParamsList_1 = __values(queryParamsList), queryParamsList_1_1 = queryParamsList_1.next(); !queryParamsList_1_1.done; queryParamsList_1_1 = queryParamsList_1.next()) {
                    var queryParam = queryParamsList_1_1.value;
                    params = params.append(queryParam.name, queryParam.value);
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (queryParamsList_1_1 && !queryParamsList_1_1.done && (_a = queryParamsList_1.return)) _a.call(queryParamsList_1);
                }
                finally { if (e_1) throw e_1.error; }
            }
            return this.httpService.post('/relations/traverse', null, { params: params });
        };
        RelationRest.decorators = [
            { type: core.Injectable }
        ];
        /** @nocollapse */
        RelationRest.ctorParameters = function () { return [
            { type: http.HttpClient }
        ]; };
        return RelationRest;
    }());
    if (false) {
        /** @type {?} */
        RelationRest.prototype.httpService;
    }
    /**
     * \@generator rest2ts
     * 	javaType: inc.yukawa.chain.crm.partner.service.rest.ReminderRest <br/>
     */
    var ReminderRest = /** @class */ (function () {
        function ReminderRest(httpService) {
            this.httpService = httpService;
        }
        ReminderRest.decorators = [
            { type: core.Injectable }
        ];
        /** @nocollapse */
        ReminderRest.ctorParameters = function () { return [
            { type: http.HttpClient }
        ]; };
        return ReminderRest;
    }());
    if (false) {
        /** @type {?} */
        ReminderRest.prototype.httpService;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * \@toDo * [ww] 'Account' => Partner
     * @deprecated
     * @record
     */
    function PartnerAspect() { }
    if (false) {
        /**
         * @param {?} filter
         * @return {?}
         */
        PartnerAspect.prototype.queryAccount = function (filter) { };
        /**
         * @param {?} id
         * @param {?} shortName
         * @return {?}
         */
        PartnerAspect.prototype.loadAccount = function (id, shortName) { };
        /**
         * @param {?} partner
         * @return {?}
         */
        PartnerAspect.prototype.saveAccount = function (partner) { };
        /**
         * @param {?} id
         * @return {?}
         */
        PartnerAspect.prototype.deleteAccount = function (id) { };
        /**
         * @param {?} id
         * @param {?} shortName
         * @return {?}
         */
        PartnerAspect.prototype.newAccount = function (id, shortName) { };
        /**
         * @param {?} filter
         * @return {?}
         */
        PartnerAspect.prototype.export = function (filter) { };
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    // services
    var CRMCoreModule = /** @class */ (function () {
        function CRMCoreModule() {
        }
        /**
         * @return {?}
         */
        CRMCoreModule.forRoot = /**
         * @return {?}
         */
        function () {
            return {
                ngModule: CRMCoreModule,
                providers: [
                    AccountService, ContactLogService, RelationService, RelationConfigService
                ]
            };
        };
        CRMCoreModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [
                            common.CommonModule,
                            http.HttpClientModule,
                            core$1.TranslateModule.forChild()
                        ],
                        declarations: [],
                        exports: [],
                        providers: [],
                        entryComponents: [],
                        schemas: [core.CUSTOM_ELEMENTS_SCHEMA]
                    },] }
        ];
        return CRMCoreModule;
    }());

    exports.AccountService = AccountService;
    exports.AccountUtilities = AccountUtilities;
    exports.AddressUtils = AddressUtils;
    exports.CRMCoreModule = CRMCoreModule;
    exports.ContactLogRest = ContactLogRest;
    exports.ContactLogService = ContactLogService;
    exports.PartnerRest = PartnerRest;
    exports.PartnerType = PartnerType;
    exports.RelationConfigService = RelationConfigService;
    exports.RelationRest = RelationRest;
    exports.RelationRole = RelationRole;
    exports.RelationService = RelationService;
    exports.ReminderRest = ReminderRest;
    exports.partnerTypes = partnerTypes;
    exports.relationRoles = relationRoles;
    exports.relationsConfig = relationsConfig;
    exports.sortByCompanyName = sortByCompanyName;
    exports.sortByLastName = sortByLastName;
    exports.withId = withId;
    exports.withType = withType;
    exports.ɵa = PartnerType$1;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=yukawa-chain-crm-angular-core.umd.js.map
