export declare enum PartnerType {
    COMPANY = "company",
    PERSON = "person"
}
export declare const partnerTypes: string[];
export interface RelationConfig {
    source: PartnerType;
    target: PartnerType;
    role: string;
    relation: string;
    inverseRelation: string;
    perspective?: 'source' | 'target';
}
