import { Observable } from "rxjs";
import { QueryResult, EditResult } from '@yukawa/chain-base-angular-domain';
import { AccountFilter } from './filter';
import { Partner } from "../../gen/domain";
export interface AccountAspect {
    Accounts: Account[];
    queryAccount(filter: AccountFilter | any): Observable<QueryResult<Partner>>;
    loadAccount(id: string, shortName: string): Observable<Partner>;
    saveAccount(partner: Partner): Observable<any>;
    deleteAccount(id: any): Observable<EditResult>;
    newAccount(id: string, shortName: string): Observable<Partner>;
}
