import { FormBuilder, FormGroup } from "@angular/forms";
import { Address } from "@yukawa/chain-base-angular-domain";
export declare class AddressUtils {
    static readonly TYPE_INVOICE = "INVOICE";
    constructor();
    static findAddressByType(address: Address[], type: string): Address;
    static getFormGroup(fb: FormBuilder, initial?: Address, validators?: Map<string, any[]>): FormGroup;
    static addAddressToFormArray(fa: any, fb: FormBuilder, initial?: Address): void;
    static addAndGetAddress(fa: any, fb: FormBuilder, initial?: Address): FormGroup;
}
