import { Observable } from "rxjs";
import { QueryResult, EditResult } from '@yukawa/chain-base-angular-domain';
import { Partner } from "../../gen/domain";
import { PartnerFilter } from "../../gen/filter";
/**
 * @toDo * [ww] 'Account' => Partner
 * @deprecated
 */
export interface PartnerAspect {
    queryAccount(filter: PartnerFilter | any): Observable<QueryResult<Partner>>;
    loadAccount(id: string, shortName: string): Observable<Partner>;
    saveAccount(partner: Partner): Observable<any>;
    deleteAccount(id: any): Observable<EditResult>;
    newAccount(id: string, shortName: string): Observable<Partner>;
    export(filter: PartnerFilter | any): Observable<Blob>;
}
