import { TableFilter } from "@yukawa/chain-base-angular-domain";
export interface AccountFilter extends TableFilter {
    keyword?: string;
    partnerType: "person" | "company";
}
export interface RelationFilter extends TableFilter {
    keyword?: string;
    partnerId?: string;
    partnerTargetId?: string;
    partnerSourceId?: string;
    targetOrSourceIds?: string[];
    role?: string;
}
export interface ContactLogFilter extends TableFilter {
    keyword?: string;
    partnerId?: string;
    communicationChannel?: string;
    participantId?: string;
}
