import { Partner, PartnerInfo } from "../../gen/domain";
import { Subject } from "rxjs";
import { FormControl } from "@angular/forms";
export declare const withType: (partner: Partner | PartnerInfo, type: string) => boolean;
export declare const withId: (partner: Partner | PartnerInfo, id: string) => boolean;
export declare const sortByCompanyName: (p1: Partner, p2: Partner) => number;
export declare const sortByLastName: (p1: Partner, p2: Partner) => number;
export declare class AccountUtilities {
    partner: Partner[];
    static getPartnerById(partners: Partner[], partnerId: string): Partner;
    static getDisplayName(partner: Partner | PartnerInfo, partnerType?: string): string;
    static compareWith(partner1: any, partner2: any): boolean | -1;
    static buildPartnerInfo(partner: any): PartnerInfo;
    static filterAccounts(accounts: Partner[], subject: Subject<any>, filterCtrl: FormControl): void;
}
