import { EntityFilter, LocalDateRange } from '@yukawa/chain-base-angular-domain';
/**
*	@generator rest2ts
*	javaType: inc.yukawa.chain.crm.base.core.filter.ContactLogFilter <br/>
*/
/**
*	@generator rest2ts
*	javaType: inc.yukawa.chain.crm.base.core.filter.PartnerFilter <br/>
*/
export interface PartnerFilter extends EntityFilter {
    classification?: string;
    companyName?: string;
    email?: string;
    firstName?: string;
    lastName?: string;
    mobile?: string;
    partnerId?: string;
    partnerType?: string;
    phoneNumber?: string;
    preferredCommunicationChannel?: string;
    role?: string;
}
/**
*	@generator rest2ts
*	javaType: inc.yukawa.chain.crm.base.core.filter.RelationFilter <br/>
*/
/**
*	@generator rest2ts
*	javaType: inc.yukawa.chain.crm.base.core.filter.ReminderFilter <br/>
*/
export interface ReminderFilter extends EntityFilter {
    communicationChannel?: string;
    dueDateRange?: LocalDateRange;
    notes?: string;
    reminderId?: string;
    reminderPartnerId?: string;
    status?: string;
}
